//
// PaletteEntry.cpp
// TPaletteEntry implementation
//

#include "PaletteEntry.h"
#include <Alert.h>

TPaletteEntry::TPaletteEntry(image_id imgID, const char *name, const char *classname)
: m_imgID(imgID)
, m_Name(name)
, m_ClassName(classname)
, m_button(0)
, m_Component(0)
{}

TPaletteEntry::~TPaletteEntry(void)
{
  // delete anything that needs deleted here
}

void TPaletteEntry::GetButtonSize(BPoint* point)
{
  float	width, height;
  if(m_button)
  {
    m_button->GetPreferredSize(&width, &height);
	point->x = width;
	point->y = height;
  }
}

void TPaletteEntry::Init(BView* view, BPoint topleft)
{
  TPaletteEntry *entry = this;

  // Create the palette button.
  BMessage* msg = new BMessage(MSG_PALENTRY);
  msg->AddPointer( "palEntry", entry);
  BRect rect(0, 0, PAL_BTN_WIDTH, PAL_BTN_HEIGHT);
  rect.OffsetTo(topleft);
  m_button = new BButton(rect, ComponentName(), ComponentName(), msg);

  view->LockLooper();
  view->AddChild(m_button);
  m_button->SetTarget(view);
  view->UnlockLooper();
}

void TPaletteEntry::About(void)
{
  (new BAlert(ComponentName(), Copyright(), "Okay"))->Go();
}

